unit THLib;

interface

uses
  Windows, Messages;
  
const
	CARDTYPE_DST_FTA_CARD= 0;
	CARDTYPE_DST_CI_CARD= 1;
	CARDTYPE_DCT_FTA_CARD= 2;
	CARDTYPE_DCT_CI_CARD= 3;

	LNBTYPE_NORMAL=	0;
	LNBTYPE_UNIVERSAL= 1;
	LNBTYPE_CUSTOM=	2;

	STATUS_SCANNING= 0;
	STATUS_SCAN_COMPLETE= 1;
	STATUS_SCAN_ERROR= 2;

	SETPID_BOTH_STREAM= 0;
	SETPID_SIGNAL_STREAM= 1;
	SETPID_PREVIEW=	2;
	SETPID_TS_STREAM= 3;

	CA_INFO_MAX_COUNT= 8;

	VIDEOFORMAT_NTSC_M= 1;
	VIDEOFORMAT_NTSC_JAPAN=	2;
	VIDEOFORMAT_PAL_BDGHI= 3;
	VIDEOFORMAT_PAL_M= 4;
	VIDEOFORMAT_PAL_N= 5;
	VIDEOFORMAT_SECAM= 6;

	CLSID_DVBSource: TGUID = '{7CDF271B-B889-4cfb-9F61-9D5E7C180894}';
	CLSID_DVBSourceProp: TGUID = '{CB21DC73-9CBA-4d5e-918F-8E85192B3B28}';
	IID_IDVBSource: TGUID = '{8430234F-D800-42a6-948E-237A0BE659A0}';


type
  PCIConfig = record
    VendorID: Word;
    DeviceID: Word;
    Command: Word;
    Status: Word;
    RevisionID: Word;
    SubVendorID: Word;
    SubSystemID: Word;
  end {PCIConfigStruct};

type
  CAInfo = record
    CA_system_ID: LongInt;
    ECM: LongInt;
    EMM: LongInt;
  end {CAInfoStruct};

type
  MMIInfo = record
    Header: Array[0..256-1] of Char;
    SubHeader: Array[0..256-1] of Char;
    ButtomLine: Array[0..256-1] of Char;
    MenuItem: Array[0..9-1] of Array[0..42-1] of Char;
    ItemCount: Integer;
    EnqFlag: Bool;
    Blind_Answer: Bool;
    Answer_Text_Length: Integer;
    Prompt: Array[0..256-1] of Char;
    Answer: Integer;
    AnswerStr: Array[0..256-1] of Char;
  end {MMIInfoStruct};

type
  AppInfo = record
    app_type: Word;
    application_manufacture: Word;
    manufacture_code: Word;
    application_info: Array[0..64-1] of Char;
  end {AppInfoStruct};

type
  ProgramValue = record
    Frequency: LongInt;
    SymbolRate: LongInt;
    HV: Integer;
    Video_Pid: LongInt;
    Audio_Pid: Array[0..5-1] of LongInt;
    Language: Array[0..5-1] of Array[0..8-1] of Char;
    PMT_PID: LongInt;
    Program_Number: LongInt;
    Scrambled: Bool;
    Program_Name: Array[0..256-1] of Char;
    Service_Provider_Name: Array[0..256-1] of Char;
    Next: pointer;
  end {ProgramValueStruct};

type
  ProgramValueSenior = record
    Program_Name: Array[0..30-1] of Char;
    Service_Provider_Name: Array[0..30-1] of Char;
    Service_ID: LongInt;
    Service_Type: LongInt;
    Transponder_Stream_ID: LongInt;
    PMT_Pid: LongInt;
    PCR_Pid: LongInt;
    Video_Pid: LongInt;
    Audio_Pid: LongInt;
    Scrambled: Bool;
    Teletext_Pid: LongInt;
    CA_system_ID: LongInt;
    CA_Pid: LongInt;
    CA_Info_Count: Integer;
    CA_Info: Array[0..CA_INFO_MAX_COUNT-1] of CAINFO;
    Next: Pointer;
  end {ProgramValueSeniorStruct};     

type
    IDVBSource = interface(IUnknown)
      ['{8430234F-D800-42a6-948E-237A0BE659A0}']
  	procedure set_LNBType(LNBType, LNB1, LNB2: Integer); stdcall;
  	procedure get_LNBType(var LNBType, LNB1, LNB2: Integer); stdcall;
        procedure LockChannel(Frequency, SymbolRate: Cardinal; HV, Tone, DiSEqC: Integer); stdcall;
  	procedure SetPID(SetType: Integer; VIdeoPID1, AudioPID1: LongInt; Scrambled: Boolean; PMTPID, ProgramNumber, VideoPID2, AudioPID2: LongInt); stdcall;
        procedure ScanChannel(); stdcall;
        procedure QueryScanStatus(var Status, ProgramNum: integer); stdcall;
                                                	//[out] return the status of scanning
							//		0: scanning
							//		1: scanning complete
							//		2: occur error and scanning exist
							//		others: not valid value
                                                        //[out] when Status return 1, this var is valid
        procedure ReadChannel(var pProgramValue: ProgramValue; var pProgramValueSenior); stdcall;
							//[out] the size according to ProgramNum
							//[out] the size according to ProgramNum
  	procedure GetSignalState(var LockFlag: Bool; var Strength, Quality: Integer); stdcall;
end;


implementation

end.
 