unit THScan1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActiveX, ComObj, StdCtrls, DSPack, DirectShow9, DSUtil, ExtCtrls,
  ComCtrls, Gauges, DateUtils, THLib;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Edit_StartF: TEdit;
    Edit_EndF: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit_Step: TEdit;
    Memo_Note: TMemo;
    Memo_Out: TMemo;
    Edit_SigH: TEdit;
    Label6: TLabel;
    FilterGraph1: TFilterGraph;
    RadioGroup1: TRadioGroup;
    Button_Stop: TButton;
    Memo_SRate: TMemo;
    Memo_Save: TMemo;
    Gauge1: TGauge;
    Label1: TLabel;
    Gauge2: TGauge;
    Label2: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    RadioGroup2: TRadioGroup;
    Label10: TLabel;
    Edit_DiSEqC: TEdit;
    UpDown1: TUpDown;
    procedure Button1Click(Sender: TObject);
    procedure Button_StopClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  bStop: Boolean;

implementation

{$R *.dfm}
{$D+}
function CompareGUIDs(const A: TGUID; const B: TGUID): Boolean;
type
  TGUIDParts = array[0..3] of LongWord;
var
  AA: TGUIDParts absolute A;
  BB: TGUIDParts absolute B;
  I: Integer;
  bSame: Array [0..3] of boolean;
begin
  for I := 0 to 3 do
    Begin
     if (AA[I] = BB[I]) then bSame[I]:=TRUE
     else bSame[I]:=FALSE;
    end;
  if bSame[0] and bSame[1] and bSame[2] and bSame[3] then Result:=TRUE
  else Result:=FALSE;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  GraphBuilder : IGraphBuilder;
  sysenum: TSysDevEnum;
  MyFilter: IBaseFilter;
  SourceI: IDVBSource;
  bLock: Bool;
  I, nStrength, nQuality, nLockCount, nLNBType, nDiSEqC: Integer;
  nSymbol, nFreq, nPol, nStep, nSigH, nTemp, nLooper, nLastLock: Integer;
  Info, svLock, DateTimeStamp: String;
begin
  bStop:=FALSE;
  form1.Button_Stop.Enabled:=TRUE;
  nLastLock:= 0;
  nLockCount:=0;
  form1.Gauge1.Progress:=0;
  form1.Gauge2.Progress:=0;
  form1.FilterGraph1.ClearGraph;
  form1.FilterGraph1.Active := True;
  form1.FilterGraph1.GraphEdit:=TRUE;
  //Get IGraphBuilder interface into GraphBuilder
  form1.FilterGraph1.QueryInterface(IGraphBuilder, GraphBuilder);
  //Add filter to Filtergraph
  sysenum := TSysDevEnum.Create;
  //Get DirectShow Filter Group
  sysenum.SelectGUIDCategory(CLSID_LegacyAmFilterCategory);
  //Add DVBSource
  if SysEnum.CountFilters > 0 then
    Begin
      for I:= 0 to (sysEnum.CountFilters -1) do
        Begin
          info := sysenum.Filters[i].FriendlyName;
          if CompareGUIDs(sysenum.Filters[i].CLSID, CLSID_DVBSource) then
           begin
             MyFilter:= SysEnum.GetBaseFilter(I);
             GraphBuilder.AddFilter(MyFilter, StringToOleStr(Info)); //ADD DVBSource
             Break;
           end;
        end;
    end;
  sysenum.Destroy;
  MyFilter.QueryInterface(IID_IDVBSource, SourceI);
  //Get DiSEqC Switch position
  nDiSEqC:=StrToInt(form1.Edit_DiSEqC.Text);
  //Get LNB type from UI and set it
  nLNBType:= form1.RadioGroup2.ItemIndex;
  SourceI.set_LNBType(nLNBType, 0, 0);
  //Before Loop
  form1.Memo_Out.Lines.Clear;
  form1.Memo_Out.Clear;
  form1.Memo_Out.Lines.Add('****Started at ' + DateTimeToStr(Now));
  //Setup Log File
  form1.Memo_Save.Lines.Clear;
  form1.Memo_Save.Lines.Add(';****Started at ' + DateTimeToStr(Now));
  form1.Memo_Save.Lines.Add('[SATTYPE]');
  form1.Memo_Save.Lines.Add('1=0001');
  form1.Memo_Save.Lines.Add('2=THScan');
  form1.Memo_Save.Lines.Add('');
  form1.Memo_Save.Lines.Add('[DVB]');
  //Get values from form
  nStep:= strtoint(form1.Edit_Step.Text);
  nTemp:= (strtoint(form1.Edit_EndF.Text) - StrToInt(form1.Edit_StartF.Text)) div nStep;
  nFreq:= StrToInt(form1.Edit_StartF.Text);
  nSigH:= StrToInt(form1.Edit_SigH.Text);
  nPol:= form1.RadioGroup1.ItemIndex;   //Get Horizontal or Vertical
  //if form1.Radio_H.Checked then nPol:= 1 else nPol:=0;
  for I:= 1 to (nTemp + 1) do
    Begin
      form1.Gauge1.Progress:= Trunc((I / nTemp) * 100);
      form1.Gauge2.Progress:=0;
      for nLooper:= 0 to (Memo_SRate.Lines.Count -1) do
        Begin
          form1.Gauge2.Progress:= Trunc((nLooper / (Memo_SRate.Lines.Count -1)) * 100);
          //If line is blank or not an integer skip it
          //if Memo_SRate.Lines.Strings[nLooper] = '' then Continue;
          Try
            nSymbol:= StrToInt(Memo_SRate.Lines.Strings[nLooper]);  //Get next symbol Rate
          Except
            Continue;
          end;
          if (nLooper = 0) and (nLastLock > 0) then nSymbol:= nLastLock;  //Try last sucessful symbol rate first.
          if nSymbol = 0 then Continue;                                 //Skip a 0 symbol rate, is there for last lock to replace
          SourceI.LockChannel(nFreq, nSymbol, nPol, 0, nDiSEqC);  //Try to Lock Frequency
          bLock:=FALSE;                                     //Reset Vars to zero vlaues
          nStrength:=0;
          nQuality:=0;
          SourceI.GetSignalState(bLock, nStrength, nQuality);  //Get state of signal
          if bLock then
            Begin
              svLock:= 'Locked!';
              nLastLock:= nSymbol;
              //Write good frequency to log file
              nLockCount:= nLockCount + 1;
              if form1.RadioGroup1.ItemIndex=1 then form1.Memo_Save.Lines.Add(IntToStr(nLockCOunt) + '=' + IntToStr(nFreq) + ',H,' + IntToStr(nSymbol))
              else form1.Memo_Save.Lines.Add(IntToStr(nLockCOunt) + '=' + IntToStr(nFreq) + ',V,' + IntToStr(nSymbol));
            end
          else svLock:= '';   //Make Lock string if signal locked
          if nStrength < nSigH then Break;                      //Break if signal is below signal threashold set by user
          form1.Memo_Out.Lines.Add(svLock + ' ' + IntTOStr(nFreq) + ' @ ' + IntToStr(nSymbol) + '    Strength= ' + IntToStr(nStrength) + '% - Quality= ' + IntToStr(nQuality) + '%');
          forms.Application.ProcessMessages;                //Handle form messages
          if bStop or bLock then break;                   //Stop if user presses the stop button or there is a frequency lock
        end;
      if bStop then break;                              //Stop if user presses the stop button
      nFreq:= nFreq + nStep;                            //incriment the frequency
    end;
  //after loop
  form1.Memo_Save.Lines.Insert(6, '0=' + IntToStr(nLockCount)); //Add Number of Signals Found
  form1.Memo_Out.Lines.Add('****Finished at ' + DateTimeToStr(Now));
  form1.Memo_Save.Lines.Add('****Finished at ' + DateTimeToStr(Now));
  //Generate Date & Time String for File Name
  DateTimeStamp:= '_' + IntToStr(Dayof(Now)) + '_' + IntToStr(MonthOf(Now)) + '_' + IntToStr(YearOf(Now)) + '_' + IntToStr(HourOf(Now)) + '_' + IntToStr(MinuteOf(Now));
  //Save Log file with Date Time Stamp
  form1.Memo_Save.Lines.SaveToFile(ExtractFilePath(forms.Application.ExeName) + '\THScan' + DateTimeStamp +'.log');
  form1.FilterGraph1.Active:=FALSE;
  form1.FilterGraph1.ClearGraph;
  form1.Button_Stop.Enabled:=TRUE;
end;

procedure TForm1.Button_StopClick(Sender: TObject);
begin
  bStop:=TRUE;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  form1.Memo_SRate.Lines.Clear;
  form1.Memo_SRate.Lines.LoadFromFile(ExtractFilePath(forms.Application.ExeName) + '\symbol.txt');
  form1.Memo_SRate.Lines.Insert(0, '0');
end;

end.
